<?php
namespace Claromentis\Core\Security;

$GLOBALS["__65da1b1ec2d6653e8a0" . "ab7848e536215"] = (@$GLOBALS["__65da1b1ec2d6653e8a0ab7848" . "e536215"] ?: array()) + array("_24e0e36600d6af77406a44bb61" . "8a6253" => base64_decode("dXNl" . "cg=="), "_77649368bc532d9bc06ddad8" . "a50096a2" => base64_decode("QXBwbGljYXRpb24gcmVxdWlyZXMgYWRtaW4gYWNjZXNzLCBidXQgZ" . "G9lc24ndCBzcGVjaWZ5IHBhbmVsIGNvZGU="), "_6a11dd42eb3818bd9" . "995b593e850c7ea" => base64_decode("Rm9yY2VkIHBh" . "c3N3b3JkIGNo" . "YW5nZQ=="), "_858e845b028b7014" . "06de2d127009c941" => base64_decode("cGFuZWxfY29" . "kZQ=="), "_965e72db2" . "455ea91167" . "79414f0627" . "46a" => base64_decode("WW91IG5lZWQ" . "gdG8gY2hhbm" . "dlIHlvdXIgc" . "GFzc3dvcmQ="), "_d5e3acfe493fa2111d22dfb93da" . "33d87" => base64_decode("X1" . "8="), "_5269083028" . "d2f37d24843" . "e7b56f80025" => base64_decode("c2VjdXJ" . "pdHkucm" . "VzdHJpY" . "3Rpb24="), "_14feb73" . "099827a3" . "0c31c0b9" . "96c13f13" . "c" => base64_decode("b25LZXJuZWxSZXF" . "1ZXN0"), "_7f628626" . "dd1d55c71" . "b1fc0932f" . "fd1d2c" => base64_decode("aXNf" . "YXJy" . "YXk="), "_cc6b63c" . "64fd515a" . "5b0110d3" . "b97a814e" . "b" => base64_decode("QXV0aGVudGljYXRpb24gcmVxdWlyZWQ" . "="), "_8059e2ba" . "ce3311190" . "b0a85f870" . "9f7a6a" => base64_decode("YWRtaW" . "4="), "_c7a35cdd86375" . "3e83240fbb3e73" . "2a6b7" => base64_decode("bm9u" . "ZQ=="), "_fdd279667944aa31b47cee7c" . "4488495f" => base64_decode("JywgYnV0IGl0J3Mg" . "bm90IGdpdmVu"), "_6f8bc3b51b" . "049d89dacde" . "43983139a56" => base64_decode("X3J" . "vdX" . "Rl"), "_0521fbd3b7" . "45045e76442" . "13cbed21a21" => base64_decode("c2VjdXJpdHkuZXh0" . "cmE="), "_4dc7dd1d92608d7c4edca7dab" . "d0206ce" => base64_decode("b25LZXJuZWxGaW5pc2hSZXF1ZXN" . "0"), "_7adf80c15f537637512f7766" . "d5fa0b2f" => base64_decode("c2VjdX" . "JpdHku" . "bW9kZQ" . "=="), "_5ce040ae4c22329c2" . "682c368b68b3611" => base64_decode("UmVxdWVzdG" . "VkIGFjY2Vz" . "cyAn"));
use Claromentis\Core\Admin\CurrentPanel;
use Claromentis\Core\Event\EventSubscriberInterface;
use Claromentis\Core\Security\Exception\AccessDeniedException;
use Claromentis\Core\Security\Exception\AdminAccessDeniedException;
use Claromentis\Core\Security\Exception\AuthenticationException;
use Claromentis\Core\Security\Exception\BadCredentialsException;
use Claromentis\Core\Security\Exception\ForcedPasswordChangeException;
use Claromentis\Core\Security\Exception\InvalidConfigException;
use Psr\Log\LoggerInterface;
use Symfony\Component\EventDispatcher\EventDispatcherInterface;
use Symfony\Component\HttpKernel\Event\FinishRequestEvent;
use Symfony\Component\HttpKernel\Event\RequestEvent;
use Symfony\Component\HttpKernel\KernelEvents;
use Symfony\Component\Routing\RouteCollection;






class Firewall implements EventSubscriberInterface
{
    protected $routes;
    protected $auth_mode_manager;
    protected $context;
    protected $dispatcher;
    protected $logger;
    protected $exception_listeners;
    public function __construct(RouteCollection $_6c20f4873f12c6bcced6c1dda9a06b86, AuthenticationModeManager $_f6b575597c272e12f16dc922e604c11d, SessionSecurityContext $context, EventDispatcherInterface $_b497ce6f2af10f67516aed0ecf34d8cf, LoggerInterface $logger = null, CurrentPanel $_777fee2a9f69c8905bdc4ffffa7d93cf = null)
    {
        $this->routes = $_6c20f4873f12c6bcced6c1dda9a06b86;
        $this->auth_mode_manager = $_f6b575597c272e12f16dc922e604c11d;
        $this->context = $context;
        $this->dispatcher = $_b497ce6f2af10f67516aed0ecf34d8cf;
        $this->logger = $logger;
        $this->current_panel = $_777fee2a9f69c8905bdc4ffffa7d93cf;
        $this->exception_listeners = new \SplObjectStorage();
    }
    
    
    
    
    public static function getSubscribedEvents()
    {
        return array(KernelEvents::REQUEST => array($GLOBALS["__65da1b1ec2d6653e8a0ab7848" . "e536215"]["_14feb73099827a30c31c" . "0b996c13f13c"], 8), KernelEvents::FINISH_REQUEST => $GLOBALS["__65da1b1ec2d6" . "653e8a0ab7848e" . "536215"]["_4dc7dd1d92608d7c4edca7dabd02" . "06ce"]);
    }
    public function onKernelFinishRequest(FinishRequestEvent $event)
    {
        $request = $event->getRequest();
        
        
        if (isset($this->exception_listeners[$request])) {
            
            
            $_ee62014f4ef50dbe8eb79b2406d87bc7 = $this->exception_listeners[$request];
            $_ee62014f4ef50dbe8eb79b2406d87bc7->unregister($this->dispatcher);
            unset($this->exception_listeners[$request]);
        }
    }
    
    
    
    
    
    
    
    
    
    protected function VerifyAccess(RequestEvent $event, $_601a171d59986f7c15972b586685671b, $_3de589dc8908aa0acc1d667051a758f3, $_4a033bdf0ce701c6255d5238633ab2d0)
    {
        $request = $event->getRequest();
        $_76b40b4ffb78489ccdf0fef0a81963f5 = $this->auth_mode_manager->GetExceptionListener($_601a171d59986f7c15972b586685671b);
        
        
        if (null !== $_76b40b4ffb78489ccdf0fef0a81963f5) {
            $this->exception_listeners[$request] = $_76b40b4ffb78489ccdf0fef0a81963f5;
            $_76b40b4ffb78489ccdf0fef0a81963f5->register($this->dispatcher);
        }
        if ($_3de589dc8908aa0acc1d667051a758f3 !== $GLOBALS["__65da1b1ec2d6653e8a0ab7" . "848e536215"]["_c7a35cdd863753e83240fbb3e732" . "a6b7"]) {
            $_b911cc8a777886afea194de4534beffa = $this->auth_mode_manager->GetAuthenticators($_601a171d59986f7c15972b586685671b);
            foreach ($_b911cc8a777886afea194de4534beffa as $_bcd36e5a5ed036659bc02cdfe807a094) {
                $_bcd36e5a5ed036659bc02cdfe807a094->Handle($event, $this->context);
                if ($event->hasResponse()) {
                    return;
                }
            }
        }
        $_34142f0805685e788bb54a01fb3e222c = null;
        if ($_3de589dc8908aa0acc1d667051a758f3 === $GLOBALS["__65da1b1ec2d6653e" . "8a0ab7848e536215"]["_8059e2bace3311190b0a85" . "f8709f7a6a"]) {
            if (!$GLOBALS["__65da1b1ec2d6653e8a0ab7848" . "e536215"]["_7f628626d" . "d1d55c71b1" . "fc0932ffd1" . "d2c"]($_4a033bdf0ce701c6255d5238633ab2d0) || empty($_4a033bdf0ce701c6255d5238633ab2d0[$GLOBALS["__65da1b1ec2d6653e8" . "a0ab7848e536215"]["_858e845b028b70" . "1406de2d127009c" . "941"]])) {
                throw new InvalidConfigException($GLOBALS["__65da1b1ec2d6653e8a" . "0ab7848e536215"]["_77649368bc532d9b" . "c06ddad8a50096a2"]);
            }
            $_34142f0805685e788bb54a01fb3e222c = $_4a033bdf0ce701c6255d5238633ab2d0[$GLOBALS["__65da1b1ec2d6653" . "e8a0ab7848e536215"]["_858e845b028b701406de2d1270" . "09c941"]];
            $_3de589dc8908aa0acc1d667051a758f3 = $GLOBALS["__65da1b1ec2d6653e8a0ab7848e" . "536215"]["_24e0e3660" . "0d6af77406" . "a44bb618a6" . "253"];
        }
        if (!$this->context->IsGranted($_3de589dc8908aa0acc1d667051a758f3)) {
            if (null !== $this->logger) {
                $this->logger->error($GLOBALS["__65da1b1ec2d6653" . "e8a0ab7848e536215"]["_5ce040ae" . "4c22329c2" . "682c368b6" . "8b3611"] . $_3de589dc8908aa0acc1d667051a758f3 . $GLOBALS["__65da1b1ec2d6653e8a0ab7848e53621" . "5"]["_fdd279667944aa31b47cee" . "7c4488495f"], [$this->context]);
            }
            if (!$this->context->GetUserId()) {
                throw new AccessDeniedException($GLOBALS["__65da1b1ec" . "2d6653e8a0a" . "b7848e53621" . "5"]["_cc6b63c64fd515a5b0110d3b9" . "7a814eb"], 401);
            }
            throw new AccessDeniedException();
        }
        if ($_34142f0805685e788bb54a01fb3e222c !== null) {
            if (!$this->context->GetUserId()) {
                throw new AccessDeniedException($GLOBALS["__65da1b1ec2d6653e8a" . "0ab7848e536215"]["_cc6b63c64fd515a5" . "b0110d3b97a814eb"], 401);
            }
            if (!\AdminPanel::UserHasAccess($_34142f0805685e788bb54a01fb3e222c, $this->context->GetId())) {
                throw new AdminAccessDeniedException($_34142f0805685e788bb54a01fb3e222c);
            }
            if ($this->current_panel !== null) {
                $this->current_panel->Set($_34142f0805685e788bb54a01fb3e222c);
            }
        }
        $this->CheckPasswordPolicy();
    }
    
    
    
    
    
    
    
    
    public function onKernelRequest(RequestEvent $event)
    {
        $request = $event->getRequest();
        $_d7cd24af9c1ec9e84b034650f4556bdc = $request->attributes->get($GLOBALS["__65da1b1ec2d6653e8a0ab7" . "848e536215"]["_6f8bc3b51b049d89dac" . "de43983139a56"]);
        if (!($_4c24595e81e7e67a084f4708169b7ec6 = $this->routes->get($_d7cd24af9c1ec9e84b034650f4556bdc))) {
            return;
        }
        
        
        $_601a171d59986f7c15972b586685671b = $_4c24595e81e7e67a084f4708169b7ec6->getOption($GLOBALS["__65da1b1ec2d6653e8a0ab7" . "848e536215"]["_7adf80c15f53" . "7637512f7766d" . "5fa0b2f"]);
        $_3de589dc8908aa0acc1d667051a758f3 = $_4c24595e81e7e67a084f4708169b7ec6->getOption($GLOBALS["__65da1b1ec2d6653e8a0ab7848e5" . "36215"]["_5269083028d2f37" . "d24843e7b56f8002" . "5"]);
        $_4a033bdf0ce701c6255d5238633ab2d0 = $_4c24595e81e7e67a084f4708169b7ec6->getOption($GLOBALS["__65da1b1ec2d665" . "3e8a0ab7848e5362" . "15"]["_0521fbd3b745045e" . "7644213cbed21a21"]);
        $request->attributes->set($GLOBALS["__65da1b1e" . "c2d6653e8a" . "0ab7848e53" . "6215"]["_7adf80c15f537637512f" . "7766d5fa0b2f"], $_601a171d59986f7c15972b586685671b);
        $request->attributes->set($GLOBALS["__65da1b1ec" . "2d6653e8a0a" . "b7848e53621" . "5"]["_5269083028d2f37d2" . "4843e7b56f80025"], $_3de589dc8908aa0acc1d667051a758f3);
        $request->attributes->set($GLOBALS["__65da1b1ec2d6653e8a0ab" . "7848e536215"]["_0521fbd3b74504" . "5e7644213cbed21" . "a21"], $_4a033bdf0ce701c6255d5238633ab2d0);
        $this->VerifyAccess($event, $_601a171d59986f7c15972b586685671b, $_3de589dc8908aa0acc1d667051a758f3, $_4a033bdf0ce701c6255d5238633ab2d0);
    }
    
    
    
    
    protected function CheckPasswordPolicy()
    {
        
        
        
        try {
            StdAuthenticator::MODE_AJAX;
            
            
            AuthUserPasswordPolicy::Run();
        } catch (PageLoadHookRedirectException $_fe441aa3ef350bfb1a1a1ad8520dd530) {
            $this->logger->notice($GLOBALS["__65da1b1ec2d6653e8a0a" . "b7848e536215"]["_6a11dd42eb38" . "18bd9995b593e" . "850c7ea"], [$_fe441aa3ef350bfb1a1a1ad8520dd530]);
            throw new ForcedPasswordChangeException($GLOBALS["__65da1b1ec2d6653" . "e8a0ab7848e536215"]["_d5e3acfe" . "493fa2111" . "d22dfb93d" . "a33d87"]($GLOBALS["__65da1b1ec2d665" . "3e8a0ab7848e5362" . "15"]["_965e72db2455ea9116779414f0" . "62746a"]));
        }
    }
}